diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/test/lr-wpan-mac-test.cc ns-3.47/src/lr-wpan/test/lr-wpan-mac-test.cc
--- ns-3.46/src/lr-wpan/test/lr-wpan-mac-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/test/lr-wpan-mac-test.cc	2026-02-16 16:08:49.631230000 -0800
@@ -147,9 +147,10 @@
     // do not attempt to do multiple backoffs delays in its CSMA,
     // macMinBE and MacMaxCSMABackoffs has been set to 0.
 
-    LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
+    LogComponentEnableAll(LogLevel(LOG_PREFIX_NODE | LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
 
     LogComponentEnable("LrWpanMac", LOG_LEVEL_DEBUG);
+    LogComponentEnable("LrWpanPhy", LOG_LEVEL_DEBUG);
     LogComponentEnable("LrWpanCsmaCa", LOG_LEVEL_DEBUG);
     LogComponentEnable("lr-wpan-mac-test", LOG_LEVEL_DEBUG);
 
@@ -251,7 +252,7 @@
     params.m_msduHandle = 0;
 
     // Send the packet that will be rejected due to channel access failure
-    Simulator::ScheduleWithContext(1,
+    Simulator::ScheduleWithContext(dev0->GetNode()->GetId(),
                                    Seconds(0.00033),
                                    &LrWpanMac::McpsDataRequest,
                                    dev0->GetMac(),
@@ -262,7 +263,7 @@
     Ptr<Packet> p2 = Create<Packet>(60); // 60 bytes of dummy data
     params.m_dstAddr = Mac16Address("00:02");
 
-    Simulator::ScheduleWithContext(2,
+    Simulator::ScheduleWithContext(dev2->GetNode()->GetId(),
                                    Seconds(0),
                                    &LrWpanMac::McpsDataRequest,
                                    dev2->GetMac(),
@@ -345,7 +346,7 @@
      *      [00:01]                       [00:02]                             [00:03]
      *  PAN Coordinator 1 (PAN: 5)       End Device                  PAN Coordinator 2 (PAN: 7)
      *
-     *       |--------100 m----------------|----------106 m -----------------------|
+     *       |--------90 m----------------|----------188 m -----------------------|
      *  Channel 12               (Active Scan channels 11-14)                 Channel 14
      *
      * Test Setup:
@@ -407,12 +408,12 @@
 
     Ptr<ConstantPositionMobilityModel> endNodeMobility =
         CreateObject<ConstantPositionMobilityModel>();
-    endNodeMobility->SetPosition(Vector(100, 0, 0));
+    endNodeMobility->SetPosition(Vector(90, 0, 0));
     endNodeNetDevice->GetPhy()->SetMobility(endNodeMobility);
 
     Ptr<ConstantPositionMobilityModel> coord2Mobility =
         CreateObject<ConstantPositionMobilityModel>();
-    coord2Mobility->SetPosition(Vector(206, 0, 0));
+    coord2Mobility->SetPosition(Vector(188, 0, 0));
     coord2NetDevice->GetPhy()->SetMobility(coord2Mobility);
 
     // MAC layer Callbacks hooks
@@ -436,7 +437,7 @@
     params.m_bcnOrd = 15;
     params.m_sfrmOrd = 15;
     params.m_logCh = 12;
-    Simulator::ScheduleWithContext(1,
+    Simulator::ScheduleWithContext(coord1NetDevice->GetNode()->GetId(),
                                    Seconds(2),
                                    &LrWpanMac::MlmeStartRequest,
                                    coord1NetDevice->GetMac(),
@@ -459,7 +460,7 @@
     params2.m_bcnOrd = 15;
     params2.m_sfrmOrd = 15;
     params2.m_logCh = 14;
-    Simulator::ScheduleWithContext(2,
+    Simulator::ScheduleWithContext(coord2NetDevice->GetNode()->GetId(),
                                    Seconds(2),
                                    &LrWpanMac::MlmeStartRequest,
                                    coord2NetDevice->GetMac(),
@@ -476,7 +477,7 @@
     scanParams.m_scanChannels = 0x7800;
     scanParams.m_scanDuration = 14;
     scanParams.m_scanType = MLMESCAN_ACTIVE;
-    Simulator::ScheduleWithContext(1,
+    Simulator::ScheduleWithContext(endNodeNetDevice->GetNode()->GetId(),
                                    Seconds(3),
                                    &LrWpanMac::MlmeScanRequest,
                                    endNodeNetDevice->GetMac(),
@@ -636,7 +637,7 @@
 
     Ptr<ConstantPositionMobilityModel> endNodeMobility =
         CreateObject<ConstantPositionMobilityModel>();
-    endNodeMobility->SetPosition(Vector(100, 0, 0));
+    endNodeMobility->SetPosition(Vector(95, 0, 0));
     endNodeNetDevice->GetPhy()->SetMobility(endNodeMobility);
 
     // MAC layer Callbacks hooks
@@ -659,7 +660,7 @@
     params.m_bcnOrd = 15;
     params.m_sfrmOrd = 15;
     params.m_logCh = 12;
-    Simulator::ScheduleWithContext(1,
+    Simulator::ScheduleWithContext(coord1NetDevice->GetNode()->GetId(),
                                    Seconds(2),
                                    &LrWpanMac::MlmeStartRequest,
                                    coord1NetDevice->GetMac(),
@@ -678,7 +679,7 @@
     scanParams.m_chPage = 0;
     scanParams.m_scanChannels = 0x7800;
     scanParams.m_scanType = MLMESCAN_ORPHAN;
-    Simulator::ScheduleWithContext(1,
+    Simulator::ScheduleWithContext(endNodeNetDevice->GetNode()->GetId(),
                                    Seconds(3),
                                    &LrWpanMac::MlmeScanRequest,
                                    endNodeNetDevice->GetMac(),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/test/lr-wpan-phy-test.cc ns-3.47/src/lr-wpan/test/lr-wpan-phy-test.cc
--- ns-3.46/src/lr-wpan/test/lr-wpan-phy-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/lr-wpan/test/lr-wpan-phy-test.cc	2026-02-16 16:08:49.631230000 -0800
@@ -0,0 +1,252 @@
+/*
+ * Copyright (c) 2011 The Boeing Company
+ * Copyright (c) 2026 Tokushima University, Japan: Collision test and refactoring
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors: Gary Pei <guangyu.pei@boeing.com>
+ *          Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+#include "ns3/log.h"
+#include "ns3/lr-wpan-mac.h"
+#include "ns3/lr-wpan-phy.h"
+#include "ns3/packet.h"
+#include "ns3/simulator.h"
+#include "ns3/single-model-spectrum-channel.h"
+#include "ns3/test.h"
+
+using namespace ns3;
+using namespace ns3::lrwpan;
+
+/**
+ * @ingroup lr-wpan-test
+ * @ingroup tests
+ *
+ * @brief LrWpan PLME and PD Interfaces Test
+ */
+class LrWpanPlmeAndPdInterfaceTestCase : public TestCase
+{
+  public:
+    LrWpanPlmeAndPdInterfaceTestCase();
+    ~LrWpanPlmeAndPdInterfaceTestCase() override;
+
+  private:
+    uint16_t m_receivedPackets{0}; //!< Counts the number of received packets
+    void DoRun() override;
+
+    /**
+     * @brief Receives a PdData indication
+     * @param psduLength The PSDU length.
+     * @param p The packet.
+     * @param lqi The LQI.
+     * @param rssi The RSSI
+     */
+    void ReceivePdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi, int8_t rssi);
+};
+
+/**
+ * @ingroup lr-wpan-test
+ * @ingroup tests
+ *
+ * @brief Test the collision of two packets and the reaction ( packet drop )
+ *        of this collision in the packet preamble
+ */
+class LrWpanPhyCollisionTestCase : public TestCase
+{
+  public:
+    LrWpanPhyCollisionTestCase();
+    ~LrWpanPhyCollisionTestCase() override;
+
+  private:
+    uint16_t m_receivedPackets{0}; //!< Counts the number of received packets
+    int8_t m_receivedRssi{0};      //!< Saves the value of the received packet RSSI
+    uint16_t m_packetDroppedByCollision{
+        0}; //!< Counts the number of packets dropped due to collision
+    void DoRun() override;
+
+    /**
+     * @brief Receives a PdData indication
+     * @param psduLength The PSDU length.
+     * @param p The packet.
+     * @param lqi The LQI.
+     * @param rssi The RSSI
+     */
+    void ReceivePdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi, int8_t rssi);
+
+    /**
+     * @brief Callback for packet drop due to collision
+     * @param p The packet.
+     */
+    void PacketCollisionDrop(Ptr<const Packet> p);
+};
+
+LrWpanPlmeAndPdInterfaceTestCase::LrWpanPlmeAndPdInterfaceTestCase()
+    : TestCase("PLME and PD SAP IEEE 802.15.4 interfaces test")
+{
+}
+
+LrWpanPlmeAndPdInterfaceTestCase::~LrWpanPlmeAndPdInterfaceTestCase()
+{
+}
+
+void
+LrWpanPlmeAndPdInterfaceTestCase::ReceivePdDataIndication(uint32_t psduLength,
+                                                          Ptr<Packet> p,
+                                                          uint8_t lqi,
+                                                          int8_t rssi)
+{
+    NS_LOG_UNCOND("At: " << Simulator::Now() << " Received frame size: " << psduLength
+                         << " LQI: " << static_cast<uint16_t>(lqi)
+                         << " RSSI: " << static_cast<int16_t>(rssi) << " dBm.");
+
+    m_receivedPackets++;
+}
+
+void
+LrWpanPlmeAndPdInterfaceTestCase::DoRun()
+{
+    // This test create two Lr-WPAN PHYs and tests a simple transmission and reception
+    // of a packet. It tests that the PHY interfaces (PLME primitives) are working.
+
+    LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
+    LogComponentEnable("LrWpanPhy", LOG_LEVEL_ALL);
+
+    Ptr<LrWpanPhy> sender = CreateObject<LrWpanPhy>();
+    Ptr<LrWpanPhy> receiver = CreateObject<LrWpanPhy>();
+
+    // Add the SpectrumPhy to a channel and set the initial state of the PHYs
+    // This is typically taken care by the NetDevice but in this case we are using the PHY directly.
+    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
+    sender->SetChannel(channel);
+    receiver->SetChannel(channel);
+    channel->AddRx(receiver);
+    sender->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_TX_ON);
+    receiver->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_RX_ON);
+
+    receiver->SetPdDataIndicationCallback(
+        MakeCallback(&LrWpanPlmeAndPdInterfaceTestCase::ReceivePdDataIndication, this));
+
+    Ptr<Packet> p = Create<Packet>(10); // Packet with 10 bytes
+    Simulator::Schedule(Seconds(1), &LrWpanPhy::PdDataRequest, sender, p->GetSize(), p);
+
+    Simulator::Stop(Seconds(5));
+    Simulator::Run();
+
+    NS_TEST_ASSERT_MSG_GT(m_receivedPackets,
+                          0,
+                          "Error,the number of expected received packets should be more than 0");
+    Simulator::Destroy();
+}
+
+LrWpanPhyCollisionTestCase::LrWpanPhyCollisionTestCase()
+    : TestCase("Collision of two IEEE 802.15.4 frames test")
+{
+}
+
+LrWpanPhyCollisionTestCase::~LrWpanPhyCollisionTestCase()
+{
+}
+
+void
+LrWpanPhyCollisionTestCase::ReceivePdDataIndication(uint32_t psduLength,
+                                                    Ptr<Packet> p,
+                                                    uint8_t lqi,
+                                                    int8_t rssi)
+{
+    NS_LOG_UNCOND("At: " << Simulator::Now() << " Received frame size: " << psduLength
+                         << " LQI: " << static_cast<uint16_t>(lqi)
+                         << " RSSI: " << static_cast<int16_t>(rssi) << " dBm.");
+
+    m_receivedPackets++;
+    m_receivedRssi = rssi;
+}
+
+void
+LrWpanPhyCollisionTestCase::PacketCollisionDrop(Ptr<const Packet> p)
+{
+    m_packetDroppedByCollision++;
+}
+
+void
+LrWpanPhyCollisionTestCase::DoRun()
+{
+    // Test the reaction of the PHY to receiving two packets simultaneously.
+    // Since the receiver device will be in BUSY_RX state after the first packet
+    // the 2nd packet will not be received. The first packet should be received correctly and
+    // the second packet should be dropped due to collision and registered
+    // in the drop trace (PhyRxDrop).
+    // The second packet also affects the received RSSI
+    // of the first packet since more energy will be present at the moment of receiving the packet.
+    // This change on energy is also tested.
+
+    LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
+    LogComponentEnable("LrWpanPhy", LOG_LEVEL_ALL);
+
+    Ptr<LrWpanPhy> sender = CreateObject<LrWpanPhy>();
+    Ptr<LrWpanPhy> sender2 = CreateObject<LrWpanPhy>();
+    Ptr<LrWpanPhy> receiver = CreateObject<LrWpanPhy>();
+
+    // Add the SpectrumPhy to a channel and set the initial state of the PHYs
+    // This is typically taken care by the NetDevice but in this case we are using the PHY directly.
+    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
+    sender->SetChannel(channel);
+    sender2->SetChannel(channel);
+    receiver->SetChannel(channel);
+    channel->AddRx(receiver);
+
+    sender->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_TX_ON);
+    sender2->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_TX_ON);
+    receiver->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_RX_ON);
+
+    // Set the callback to receive packets at the receiver PHY
+    receiver->SetPdDataIndicationCallback(
+        MakeCallback(&LrWpanPhyCollisionTestCase::ReceivePdDataIndication, this));
+
+    // Connect to trace source to log when a packet is dropped due to collision
+    receiver->TraceConnectWithoutContext(
+        "PhyRxDrop",
+        MakeCallback(&LrWpanPhyCollisionTestCase::PacketCollisionDrop, this));
+
+    Ptr<Packet> p = Create<Packet>(10); // 10 bytes
+    Ptr<Packet> p2 = Create<Packet>(9); // 9 bytes
+    Simulator::Schedule(Seconds(2), &LrWpanPhy::PdDataRequest, sender, p->GetSize(), p);
+    Simulator::Schedule(Seconds(2), &LrWpanPhy::PdDataRequest, sender2, p2->GetSize(), p2);
+
+    Simulator::Stop(Seconds(5));
+    Simulator::Run();
+
+    NS_TEST_ASSERT_MSG_EQ(m_receivedPackets,
+                          1,
+                          "Error,the receiver should only be able to receive the first packet");
+
+    NS_TEST_ASSERT_MSG_EQ(m_packetDroppedByCollision,
+                          1,
+                          "Error, one packet should be dropped due to collision");
+
+    NS_TEST_ASSERT_MSG_GT(m_receivedRssi, 0, "Error,the received RSSI should be more than 0");
+
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup lr-wpan-test
+ * @ingroup tests
+ *
+ * @brief LrWpan PLME and PD Interfaces TestSuite
+ */
+class LrWpanPlmeAndPdInterfaceTestSuite : public TestSuite
+{
+  public:
+    LrWpanPlmeAndPdInterfaceTestSuite();
+};
+
+LrWpanPlmeAndPdInterfaceTestSuite::LrWpanPlmeAndPdInterfaceTestSuite()
+    : TestSuite("lr-wpan-phy-test", Type::UNIT)
+{
+    // AddTestCase(new LrWpanPlmeAndPdInterfaceTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new LrWpanPhyCollisionTestCase, TestCase::Duration::QUICK);
+}
+
+// Do not forget to allocate an instance of this TestSuite
+static LrWpanPlmeAndPdInterfaceTestSuite
+    g_lrWpanPlmeAndPdInterfaceTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/examples/lena-radio-link-failure.cc ns-3.47/src/lte/examples/lena-radio-link-failure.cc
--- ns-3.46/src/lte/examples/lena-radio-link-failure.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/examples/lena-radio-link-failure.cc	2026-02-16 16:08:49.658230000 -0800
@@ -470,9 +470,16 @@
     int64_t randomStream = 1;
 
     enbDevs = lteHelper->InstallEnbDevice(enbNodes);
-    randomStream += lteHelper->AssignStreams(enbDevs, randomStream);
+    // Call AssignStreams in the EpcHelper only once by setting 'assignEpcStreams' only once
+    // Then, increment the stream value by 1000 (a magic number that should ensure that there
+    // are no overlapping stream assignments) each time that AssignStreams is called,
+    // to lessen the possibility that random variable stream assignment changes propagate
+    // to other objects.
+    lteHelper->AssignStreams(enbDevs, randomStream, false);
+    randomStream += 1000;
     ueDevs = lteHelper->InstallUeDevice(ueNodes);
-    randomStream += lteHelper->AssignStreams(ueDevs, randomStream);
+    lteHelper->AssignStreams(ueDevs, randomStream, true);
+    randomStream += 1000;
 
     NS_LOG_INFO("Install the IP stack on the UEs");
     internet.Install(ueNodes);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/helper/lte-helper.cc ns-3.47/src/lte/helper/lte-helper.cc
--- ns-3.46/src/lte/helper/lte-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/helper/lte-helper.cc	2026-02-16 16:08:49.659230000 -0800
@@ -130,7 +130,8 @@
             .AddAttribute("PathlossModel",
                           "The type of pathloss model to be used. "
                           "The allowed values for this attributes are the type names "
-                          "of any class inheriting from ns3::PropagationLossModel.",
+                          "of any class inheriting from ns3::PropagationLossModel "
+                          "or ns3::SpectrumPropagationLossModel.",
                           TypeIdValue(FriisPropagationLossModel::GetTypeId()),
                           MakeTypeIdAccessor(&LteHelper::SetPathlossModelType),
                           MakeTypeIdChecker())
@@ -215,6 +216,12 @@
     return m_downlinkChannel;
 }
 
+Ptr<EpcHelper>
+LteHelper::GetEpcHelper() const
+{
+    return m_epcHelper;
+}
+
 void
 LteHelper::ChannelModelInitialization()
 {
@@ -1174,7 +1181,7 @@
  * UE change its RRC state to CONNECTED_NORMALLY, activation
  * function is called and bearer is activated.
  */
-class DrbActivator : public SimpleRefCount<DrbActivator>
+class DrbActivator
 {
   public:
     /**
@@ -1195,7 +1202,7 @@
      * @param cellId
      * @param rnti
      */
-    static void ActivateCallback(Ptr<DrbActivator> a,
+    static void ActivateCallback(std::shared_ptr<DrbActivator> a,
                                  std::string context,
                                  uint64_t imsi,
                                  uint16_t cellId,
@@ -1243,7 +1250,7 @@
 }
 
 void
-DrbActivator::ActivateCallback(Ptr<DrbActivator> a,
+DrbActivator::ActivateCallback(std::shared_ptr<DrbActivator> a,
                                std::string context,
                                uint64_t imsi,
                                uint16_t cellId,
@@ -1294,7 +1301,7 @@
     std::ostringstream path;
     path << "/NodeList/" << enbLteDevice->GetNode()->GetId() << "/DeviceList/"
          << enbLteDevice->GetIfIndex() << "/LteEnbRrc/ConnectionEstablished";
-    Ptr<DrbActivator> arg = Create<DrbActivator>(ueDevice, bearer);
+    auto arg = std::make_shared<DrbActivator>(ueDevice, bearer);
     Config::Connect(path.str(), MakeBoundCallback(&DrbActivator::ActivateCallback, arg));
 }
 
@@ -1553,8 +1560,9 @@
 }
 
 int64_t
-LteHelper::AssignStreams(NetDeviceContainer c, int64_t stream)
+LteHelper::AssignStreams(NetDeviceContainer c, int64_t stream, bool assignEpcStreams)
 {
+    NS_LOG_FUNCTION(this << stream << assignEpcStreams);
     int64_t currentStream = stream;
     if (m_fadingModel && !m_fadingStreamsAssigned)
     {
@@ -1594,7 +1602,7 @@
             currentStream += ueMac->AssignStreams(currentStream);
         }
     }
-    if (m_epcHelper)
+    if (m_epcHelper && assignEpcStreams)
     {
         currentStream += m_epcHelper->AssignStreams(currentStream);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/helper/lte-helper.h ns-3.47/src/lte/helper/lte-helper.h
--- ns-3.46/src/lte/helper/lte-helper.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/helper/lte-helper.h	2026-02-16 16:08:49.659230000 -0800
@@ -648,15 +648,16 @@
      * If TraceFadingLossModel has been set as the fading model type, this method
      * will also assign a stream number to it, if none has been assigned before.
      *
-     * If an EPC has been configured, streams will be assigned on the EPC
-     * nodes as well via EpcHelper::AssignStreams ().
+     * If an EPC has been configured, streams will be assigned on the internet stack
+     * of EPC nodes, by calling EpcHelper::AssignStreams(), if assignEpcStreams is true.
      *
      * @param c NetDeviceContainer of the set of net devices for which the
      *          LteNetDevice should be modified to use a fixed stream
      * @param stream first stream index to use
+     * @param assignEpcStreams Whether to call AssignStreams on the associated EpcHelper
      * @return the number of stream indices (possibly zero) that have been assigned
      */
-    int64_t AssignStreams(NetDeviceContainer c, int64_t stream);
+    int64_t AssignStreams(NetDeviceContainer c, int64_t stream, bool assignEpcStreams = true);
 
     /**
      * @return a pointer to the SpectrumChannel instance used for the uplink
@@ -668,6 +669,11 @@
      */
     Ptr<SpectrumChannel> GetDownlinkSpectrumChannel() const;
 
+    /**
+     * @return a pointer to the EpcHelper instance used, if any
+     */
+    Ptr<EpcHelper> GetEpcHelper() const;
+
   protected:
     // inherited from Object
     void DoInitialize() override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/helper/radio-bearer-stats-connector.cc ns-3.47/src/lte/helper/radio-bearer-stats-connector.cc
--- ns-3.46/src/lte/helper/radio-bearer-stats-connector.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/helper/radio-bearer-stats-connector.cc	2026-02-16 16:08:49.660230200 -0800
@@ -35,7 +35,7 @@
  * and provides calculators with cellId and IMSI,
  * because most trace sources do not provide it.
  */
-struct BoundCallbackArgument : public SimpleRefCount<BoundCallbackArgument>
+struct BoundCallbackArgument
 {
   public:
     Ptr<RadioBearerStatsCalculator> stats; //!< statistics calculator
@@ -52,7 +52,7 @@
  * @param packetSize
  */
 void
-DlTxPduCallback(Ptr<BoundCallbackArgument> arg,
+DlTxPduCallback(std::shared_ptr<BoundCallbackArgument> arg,
                 std::string path,
                 uint16_t rnti,
                 uint8_t lcid,
@@ -72,7 +72,7 @@
  * @param delay
  */
 void
-DlRxPduCallback(Ptr<BoundCallbackArgument> arg,
+DlRxPduCallback(std::shared_ptr<BoundCallbackArgument> arg,
                 std::string path,
                 uint16_t rnti,
                 uint8_t lcid,
@@ -92,7 +92,7 @@
  * @param packetSize
  */
 void
-UlTxPduCallback(Ptr<BoundCallbackArgument> arg,
+UlTxPduCallback(std::shared_ptr<BoundCallbackArgument> arg,
                 std::string path,
                 uint16_t rnti,
                 uint8_t lcid,
@@ -112,7 +112,7 @@
  * @param delay
  */
 void
-UlRxPduCallback(Ptr<BoundCallbackArgument> arg,
+UlRxPduCallback(std::shared_ptr<BoundCallbackArgument> arg,
                 std::string path,
                 uint16_t rnti,
                 uint8_t lcid,
@@ -255,7 +255,7 @@
     NS_LOG_LOGIC("ueManagerPath = " << ueManagerPath);
     if (m_rlcStats)
     {
-        Ptr<BoundCallbackArgument> arg = Create<BoundCallbackArgument>();
+        auto arg = std::make_shared<BoundCallbackArgument>();
         arg->imsi = imsi;
         arg->cellId = cellId;
         arg->stats = m_rlcStats;
@@ -286,7 +286,7 @@
     NS_LOG_LOGIC("ueManagerPath = " << ueManagerPath);
     if (m_rlcStats)
     {
-        Ptr<BoundCallbackArgument> arg = Create<BoundCallbackArgument>();
+        auto arg = std::make_shared<BoundCallbackArgument>();
         arg->imsi = imsi;
         arg->cellId = cellId;
         arg->stats = m_rlcStats;
@@ -299,7 +299,7 @@
     }
     if (m_pdcpStats)
     {
-        Ptr<BoundCallbackArgument> arg = Create<BoundCallbackArgument>();
+        auto arg = std::make_shared<BoundCallbackArgument>();
         arg->imsi = imsi;
         arg->cellId = cellId;
         arg->stats = m_pdcpStats;
@@ -329,7 +329,7 @@
     NS_LOG_LOGIC("basePath = " << basePath);
     if (m_rlcStats)
     {
-        Ptr<BoundCallbackArgument> arg = Create<BoundCallbackArgument>();
+        auto arg = std::make_shared<BoundCallbackArgument>();
         arg->imsi = imsi;
         arg->cellId = cellId;
         arg->stats = m_rlcStats;
@@ -338,7 +338,7 @@
     }
     if (m_pdcpStats)
     {
-        Ptr<BoundCallbackArgument> arg = Create<BoundCallbackArgument>();
+        auto arg = std::make_shared<BoundCallbackArgument>();
         arg->imsi = imsi;
         arg->cellId = cellId;
         arg->stats = m_pdcpStats;
@@ -368,7 +368,7 @@
     NS_LOG_LOGIC("basePath = " << basePath);
     if (m_rlcStats)
     {
-        Ptr<BoundCallbackArgument> arg = Create<BoundCallbackArgument>();
+        auto arg = std::make_shared<BoundCallbackArgument>();
         arg->imsi = imsi;
         arg->cellId = cellId;
         arg->stats = m_rlcStats;
@@ -377,7 +377,7 @@
     }
     if (m_pdcpStats)
     {
-        Ptr<BoundCallbackArgument> arg = Create<BoundCallbackArgument>();
+        auto arg = std::make_shared<BoundCallbackArgument>();
         arg->imsi = imsi;
         arg->cellId = cellId;
         arg->stats = m_pdcpStats;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/a2-a4-rsrq-handover-algorithm.cc ns-3.47/src/lte/model/a2-a4-rsrq-handover-algorithm.cc
--- ns-3.46/src/lte/model/a2-a4-rsrq-handover-algorithm.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/a2-a4-rsrq-handover-algorithm.cc	2026-02-16 16:08:49.660230200 -0800
@@ -234,7 +234,7 @@
     }
 
     NS_ASSERT(it1 != m_neighbourCellMeasures.end());
-    Ptr<UeMeasure> neighbourCellMeasures;
+    std::shared_ptr<UeMeasure> neighbourCellMeasures;
     auto it2 = it1->second.find(cellId);
 
     if (it2 != it1->second.end())
@@ -246,7 +246,7 @@
     else
     {
         // insert a new cell entry
-        neighbourCellMeasures = Create<UeMeasure>();
+        neighbourCellMeasures = std::make_shared<UeMeasure>();
         neighbourCellMeasures->m_cellId = cellId;
         neighbourCellMeasures->m_rsrq = rsrq;
         it1->second[cellId] = neighbourCellMeasures;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/a2-a4-rsrq-handover-algorithm.h ns-3.47/src/lte/model/a2-a4-rsrq-handover-algorithm.h
--- ns-3.46/src/lte/model/a2-a4-rsrq-handover-algorithm.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/a2-a4-rsrq-handover-algorithm.h	2026-02-16 16:08:49.660230200 -0800
@@ -135,7 +135,7 @@
      * Measurements reported by a UE for a cell ID. The values are quantized
      * according 3GPP TS 36.133 section 9.1.4 and 9.1.7.
      */
-    class UeMeasure : public SimpleRefCount<UeMeasure>
+    class UeMeasure
     {
       public:
         uint16_t m_cellId; ///< Cell ID.
@@ -146,7 +146,7 @@
      * Measurements reported by a UE for several cells. The structure is a map
      * indexed by the cell ID.
      */
-    typedef std::map<uint16_t, Ptr<UeMeasure>> MeasurementRow_t;
+    typedef std::map<uint16_t, std::shared_ptr<UeMeasure>> MeasurementRow_t;
 
     /**
      * Measurements reported by several UEs. The structure is a map indexed by
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/epc-mme-application.cc ns-3.47/src/lte/model/epc-mme-application.cc
--- ns-3.46/src/lte/model/epc-mme-application.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/epc-mme-application.cc	2026-02-16 16:08:49.662230000 -0800
@@ -70,7 +70,7 @@
 EpcMmeApplication::AddEnb(uint16_t gci, Ipv4Address enbS1uAddr, EpcS1apSapEnb* enbS1apSap)
 {
     NS_LOG_FUNCTION(this << gci << enbS1uAddr << enbS1apSap);
-    Ptr<EnbInfo> enbInfo = Create<EnbInfo>();
+    auto enbInfo = std::make_shared<EnbInfo>();
     enbInfo->gci = gci;
     enbInfo->s1uAddr = enbS1uAddr;
     enbInfo->s1apSapEnb = enbS1apSap;
@@ -81,7 +81,7 @@
 EpcMmeApplication::AddUe(uint64_t imsi)
 {
     NS_LOG_FUNCTION(this << imsi);
-    Ptr<UeInfo> ueInfo = Create<UeInfo>();
+    auto ueInfo = std::make_shared<UeInfo>();
     ueInfo->imsi = imsi;
     ueInfo->mmeUeS1Id = imsi;
     ueInfo->bearerCounter = 0;
@@ -233,7 +233,7 @@
 }
 
 void
-EpcMmeApplication::RemoveBearer(Ptr<UeInfo> ueInfo, uint8_t epsBearerId)
+EpcMmeApplication::RemoveBearer(std::shared_ptr<UeInfo> ueInfo, uint8_t epsBearerId)
 {
     NS_LOG_FUNCTION(this << epsBearerId);
     auto bit = ueInfo->bearersToBeActivated.begin();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/epc-mme-application.h ns-3.47/src/lte/model/epc-mme-application.h
--- ns-3.46/src/lte/model/epc-mme-application.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/epc-mme-application.h	2026-02-16 16:08:49.662230000 -0800
@@ -187,7 +187,7 @@
     /**
      * Hold info on a UE
      */
-    struct UeInfo : public SimpleRefCount<UeInfo>
+    struct UeInfo
     {
         uint64_t imsi;                              ///< UE identifier
         uint64_t mmeUeS1Id;                         ///< mmeUeS1Id
@@ -200,19 +200,19 @@
     /**
      * UeInfo stored by IMSI
      */
-    std::map<uint64_t, Ptr<UeInfo>> m_ueInfoMap;
+    std::map<uint64_t, std::shared_ptr<UeInfo>> m_ueInfoMap;
 
     /**
      * @brief This Function erases all contexts of bearer from MME side
      * @param ueInfo UE information pointer
      * @param epsBearerId Bearer Id which need to be removed corresponding to UE
      */
-    void RemoveBearer(Ptr<UeInfo> ueInfo, uint8_t epsBearerId);
+    void RemoveBearer(std::shared_ptr<UeInfo> ueInfo, uint8_t epsBearerId);
 
     /**
      * Hold info on an ENB
      */
-    struct EnbInfo : public SimpleRefCount<EnbInfo>
+    struct EnbInfo
     {
         uint16_t gci;              ///< GCI
         Ipv4Address s1uAddr;       ///< IP address of the S1-U interface
@@ -222,7 +222,7 @@
     /**
      * EnbInfo stored by EGCI
      */
-    std::map<uint16_t, Ptr<EnbInfo>> m_enbInfoMap;
+    std::map<uint16_t, std::shared_ptr<EnbInfo>> m_enbInfoMap;
 
     EpcS1apSapMme* m_s1apSapMme; ///< EpcS1apSapMme
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/epc-pgw-application.cc ns-3.47/src/lte/model/epc-pgw-application.cc
--- ns-3.46/src/lte/model/epc-pgw-application.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/epc-pgw-application.cc	2026-02-16 16:08:49.662230000 -0800
@@ -482,8 +482,7 @@
 EpcPgwApplication::AddUe(uint64_t imsi)
 {
     NS_LOG_FUNCTION(this << imsi);
-    Ptr<UeInfo> ueInfo = Create<UeInfo>();
-    m_ueInfoByImsiMap[imsi] = ueInfo;
+    m_ueInfoByImsiMap[imsi] = std::make_shared<UeInfo>();
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lte/model/epc-pgw-application.h ns-3.47/src/lte/model/epc-pgw-application.h
--- ns-3.46/src/lte/model/epc-pgw-application.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lte/model/epc-pgw-application.h	2026-02-16 16:08:49.662230000 -0800
@@ -182,7 +182,7 @@
     /**
      * store info for each UE connected to this PGW
      */
-    class UeInfo : public SimpleRefCount<UeInfo>
+    class UeInfo
     {
       public:
         UeInfo();
@@ -290,17 +290,17 @@
     /**
      * UeInfo stored by UE IPv4 address
      */
-    std::map<Ipv4Address, Ptr<UeInfo>> m_ueInfoByAddrMap;
+    std::map<Ipv4Address, std::shared_ptr<UeInfo>> m_ueInfoByAddrMap;
 
     /**
      * UeInfo stored by UE IPv6 address
      */
-    std::map<Ipv6Address, Ptr<UeInfo>> m_ueInfoByAddrMap6;
+    std::map<Ipv6Address, std::shared_ptr<UeInfo>> m_ueInfoByAddrMap6;
 
     /**
      * UeInfo stored by IMSI
      */
-    std::map<uint64_t, Ptr<UeInfo>> m_ueInfoByImsiMap;
+    std::map<uint64_t, std::shared_ptr<UeInfo>> m_ueInfoByImsiMap;
 
     /**
      * UDP port to be used for GTP-U
